/*
    Copyright (C) 2010 Eduardo Robles Elvira

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef SECURECLIENT_H
#define SECURECLIENT_H

#include <QtCore/QObject>
#include <QtNetwork/QSslSocket>

class QSslError;

class SecureClient : public QObject
{
    Q_OBJECT
public:
    SecureClient();
    virtual ~SecureClient();

    // Starts a connection to the given server
    void start(QString hostname, qint16 port);

private Q_SLOTS:
    // handle the signal of QSslSocket::encrypted()
    void connectionEstablished();

    // handle the signal of QSslSocket::sslErrors()
    void errorOccured(const QList<QSslError> &error);

    void hostFound();
    void connected();
    void error(QAbstractSocket::SocketError);

private:
    QSslSocket *m_socket;
};

#endif // SECURECLIENT_H
